import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.Hashtable;
import javax.swing.BorderFactory;
import javax.swing.border.*;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;

public final class SettingsDialog extends JFrame {
    JButton OKBtn = new JButton("OK");
    JButton AbortBtn = new JButton("Abort");
    String [] Presets = {"Default"};
    JComboBox DefaultCombo = new JComboBox(Presets);
    
    JPanel SimulationPanel = new JPanel();
    JPanel AlgaesPanel = new JPanel();
    JPanel SensorsPanel = new JPanel();
    JPanel ActionPanel = new JPanel();

    JPanel ActionTopPanel = new JPanel();
    JPanel ActionBottomPanel = new JPanel();

    JTabbedPane TabbedPane = new JTabbedPane();
    
    Container contentPane;

    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();

    GridBagLayout gridbag2 = new GridBagLayout();
    GridBagConstraints c2 = new GridBagConstraints();

    JPanel TopPanel = new JPanel();
    JPanel BottomPanel = new JPanel();

    JTextField DurationTF = new JTextField(5);
    JTextField WidthTF = new JTextField(3);
    JTextField HeightTF = new JTextField(3);

    JTextField IntensityTF = new JTextField(5);

    JTextField SubstrateAmountTF = new JTextField(5);
    JTextField SubstrateRenewTF = new JTextField(5);
    JTextField PheroDecreaseTF = new JTextField(5);

    JTextField InitialAlgaesTF = new JTextField(5);
    JTextField InitialEnergyTF = new JTextField(5);

    JTextField PheromoneFOVTF = new JTextField(5);
    JTextField PheromoneRangeTF = new JTextField(5);
    JTextField SubstrateFOVTF = new JTextField(5);
    JTextField SubstrateRangeTF = new JTextField(5);
    JTextField LightFOVTF = new JTextField(5);
    JTextField LightRangeTF = new JTextField(5);

    JTextField EnergyMovementTF = new JTextField(5);
    JTextField EnergyMitoseTF = new JTextField(5);
    JTextField EnergyMeioseTF = new JTextField(5);
    JTextField EnergyPOutputTF = new JTextField(5);
    JTextField EnergySubstrateTF = new JTextField(5);
    JTextField EnergyLightTF = new JTextField(5);
    
    JRadioButton AllTheTimeRB = new JRadioButton("All the time");
    JRadioButton NeverRB = new JRadioButton("Never");
    JRadioButton FunctionRB = new JRadioButton("Function");
    ButtonGroup enabledGroup = new ButtonGroup();    

    JButton SelectDistFuncBtn = new JButton("Select distribution function...");
    JButton SelectLightFuncBtn = new JButton("Select light cycle function...");

    public void MakeSimulationPanel()
    {
	GridBagLayout lBag = new GridBagLayout();
	GridBagConstraints lc = new GridBagConstraints();
	SimulationPanel.setLayout(lBag);
	
	// Duration stuff
	JLabel DurationLabel=new JLabel("Duration");
	lc.gridx = 1;
        lc.gridy = 1;
        lc.gridwidth=5;
        lc.gridheight=1;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(5,5,5,5);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(DurationLabel, lc);
	SimulationPanel.add(DurationLabel);

	lc.gridx = 1;
        lc.gridy = 2;
        lc.gridwidth=4;
        lc.gridheight=1;
        lBag.setConstraints(DurationTF, lc);
	SimulationPanel.add(DurationTF);

	JLabel StepsLabel = new JLabel("steps");
	lc.gridx = 5;
        lc.gridy = 2;
        lc.gridwidth=2;
        lc.gridheight=1;
        lBag.setConstraints(StepsLabel, lc);
	SimulationPanel.add(StepsLabel);

	// Dimension stuff
	JLabel DimensionLabel = new JLabel("Dimension");
	lc.gridx = 11;
        lc.gridy = 1;
        lc.gridwidth=4;
        lc.gridheight=1;
        lBag.setConstraints(DimensionLabel, lc);
	SimulationPanel.add(DimensionLabel);
	
	JLabel WidthLabel = new JLabel("Width");
	lc.gridx = 11;
	lc.gridy = 2;
	lc.gridwidth = 2;
	lc.gridheight = 1;
	lBag.setConstraints(WidthLabel, lc);
	SimulationPanel.add(WidthLabel);

	lc.gridx = 13;
	lc.gridy = 2;
	lc.gridwidth = 3;
	lc.gridheight = 1;
	lBag.setConstraints(WidthTF, lc);
	SimulationPanel.add(WidthTF);

	JLabel HeightLabel = new JLabel("Height");
	lc.gridx = 16;
	lc.gridy = 2;
	lc.gridwidth = 3;
	lc.gridheight = 1;
	lBag.setConstraints(HeightLabel, lc);
	SimulationPanel.add(HeightLabel);

	lc.gridx = 20;
	lc.gridy = 2;
	lc.gridwidth = 3;
	lc.gridheight = 1;
	lBag.setConstraints(HeightTF, lc);
	SimulationPanel.add(HeightTF);

	// light stuff
	JPanel LightPanel = new JPanel();
	GridBagLayout lightBag = new GridBagLayout();
	GridBagConstraints llc = new GridBagConstraints();
	LightPanel.setLayout(lightBag);
	
	lc.gridx = 0;
        lc.gridy = 4;
        lc.gridwidth=24;
        lc.gridheight=7;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(0,10,0,10);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(LightPanel, lc);
	SimulationPanel.add(LightPanel);

   	TitledBorder lightBorder= BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.black), "Light settings");
	LightPanel.setBorder(lightBorder);

       	TitledBorder enabledBorder= BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.black), "Enabled");
	JPanel EnabledPanel = new JPanel();
	EnabledPanel.setLayout(new GridLayout(3,1));
	EnabledPanel.setBorder(enabledBorder);

	AllTheTimeRB.setSelected(true);
	enabledGroup.add(AllTheTimeRB);
	enabledGroup.add(NeverRB);
	enabledGroup.add(FunctionRB);

	EnabledPanel.add(AllTheTimeRB);
	EnabledPanel.add(NeverRB);
	EnabledPanel.add(FunctionRB);

	llc.gridx = 1;
        llc.gridy = 1;
        llc.gridwidth=9;
        llc.gridheight=5;
        llc.weightx=0;
        llc.weighty=0;
        llc.insets=new Insets(5,5,5,5);
        llc.fill = GridBagConstraints.BOTH;
        lightBag.setConstraints(EnabledPanel, llc);
	LightPanel.add(EnabledPanel);

	JLabel IntensityLabel = new JLabel("Intensity");
	llc.gridx = 10;
        llc.gridy = 2;
        llc.gridwidth=5;
        llc.gridheight=1;
        llc.weightx=0;
        llc.weighty=0;
        llc.insets=new Insets(5,5,5,5);
        llc.fill = GridBagConstraints.BOTH;
        lightBag.setConstraints(IntensityLabel, llc);
	LightPanel.add(IntensityLabel);

	llc.gridx = 15;
        llc.gridy = 2;
        llc.gridwidth=5;
        llc.gridheight=1;
        llc.weightx=0;
        llc.weighty=0;
        llc.insets=new Insets(5,5,5,5);
        llc.fill = GridBagConstraints.BOTH;
        lightBag.setConstraints(IntensityTF, llc);
	LightPanel.add(IntensityTF);

	llc.gridx = 10;
        llc.gridy = 4;
        llc.gridwidth=14;
        llc.gridheight=1;
        llc.weightx=0;
        llc.weighty=0;
        llc.insets=new Insets(5,5,5,5);
        llc.fill = GridBagConstraints.BOTH;
        lightBag.setConstraints(SelectDistFuncBtn, llc);
	LightPanel.add(SelectDistFuncBtn);

	llc.gridx = 10;
        llc.gridy = 5;
        llc.gridwidth=14;
        llc.gridheight=1;
        llc.weightx=0;
        llc.weighty=0;
        llc.insets=new Insets(5,5,5,5);
        llc.fill = GridBagConstraints.BOTH;
        lightBag.setConstraints(SelectLightFuncBtn, llc);
	LightPanel.add(SelectLightFuncBtn);

	JLabel SubstrateAmountLabel = new JLabel("Substrate amount");
	lc.gridx = 0;
        lc.gridy = 11;
        lc.gridwidth=9;
        lc.gridheight=1;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(5,5,5,5);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(SubstrateAmountLabel, lc);
	SimulationPanel.add(SubstrateAmountLabel);

	lc.gridx = 10;
        lc.gridy = 11;
        lc.gridwidth=5;
        lc.gridheight=1;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(5,5,5,5);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(SubstrateAmountTF , lc);
	SimulationPanel.add(SubstrateAmountTF);

	JLabel SubstrateRenewLabel = new JLabel("Substrate renew rate");
	lc.gridx = 0;
        lc.gridy = 12;
        lc.gridwidth=10;
        lc.gridheight=1;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(5,5,5,5);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(SubstrateRenewLabel, lc);
	SimulationPanel.add(SubstrateRenewLabel);

	lc.gridx = 10;
        lc.gridy = 12;
        lc.gridwidth=5;
        lc.gridheight=1;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(5,5,5,5);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(SubstrateRenewTF, lc);
	SimulationPanel.add(SubstrateRenewTF);

	JLabel PheroDecLabel = new JLabel("Pheromone decrease rate");
	lc.gridx = 0;
        lc.gridy = 14;
        lc.gridwidth=10;
        lc.gridheight=1;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(5,5,5,5);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(PheroDecLabel, lc);
	SimulationPanel.add(PheroDecLabel);

	lc.gridx = 10;
        lc.gridy = 14;
        lc.gridwidth=5;
        lc.gridheight=1;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(5,5,5,5);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(PheroDecreaseTF, lc);
	SimulationPanel.add(PheroDecreaseTF);
    }

    public void MakeAlgaesPanel()
    {
	GridBagLayout lBag = new GridBagLayout();
	GridBagConstraints lc = new GridBagConstraints();
	AlgaesPanel.setLayout(lBag);
	
	// Number of initial Algaes - stuff
	JLabel InitialAlgaesLabel=new JLabel("# of initial Algaes");
	lc.gridx = 1;
        lc.gridy = 1;
        lc.gridwidth=8;
        lc.gridheight=1;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(5,5,5,5);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(InitialAlgaesLabel, lc);
	AlgaesPanel.add(InitialAlgaesLabel);

	lc.gridx = 1;
        lc.gridy = 2;
        lc.gridwidth=4;
        lc.gridheight=1;
        lBag.setConstraints(InitialAlgaesTF, lc);
	AlgaesPanel.add(InitialAlgaesTF);

	// initial Energylevel  - stuff
	JLabel InitialEnergyLabel=new JLabel("Initial Energylevel");
	lc.gridx = 11;
        lc.gridy = 1;
        lc.gridwidth=10;
        lc.gridheight=1;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(5,5,5,5);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(InitialEnergyLabel, lc);
	AlgaesPanel.add(InitialEnergyLabel);

	lc.gridx = 11;
        lc.gridy = 2;
        lc.gridwidth=4;
        lc.gridheight=1;
        lBag.setConstraints(InitialEnergyTF, lc);
	AlgaesPanel.add(InitialEnergyTF);
    }

    public void MakeSensorsPanel()
    {
	SensorsPanel.setLayout(new GridLayout(4,3));
	
	// Number of initial Algaes - stuff
	JLabel FOVLabel=new JLabel("FOV");
	JLabel RangeLabel=new JLabel("Range");
	JLabel PheromoneLabel=new JLabel("Pheromone");
	JLabel SubstrateLabel=new JLabel("Substrate");
	JLabel LightLabel=new JLabel("Light");
	JLabel EmptyLabel=new JLabel("  ");	
	
	SensorsPanel.add(EmptyLabel);
	SensorsPanel.add(FOVLabel);
	SensorsPanel.add(RangeLabel);

	SensorsPanel.add(PheromoneLabel);
	SensorsPanel.add(PheromoneFOVTF);
	SensorsPanel.add(PheromoneRangeTF);

	SensorsPanel.add(SubstrateLabel);
	SensorsPanel.add(SubstrateFOVTF);
	SensorsPanel.add(SubstrateRangeTF);

	SensorsPanel.add(LightLabel);
	SensorsPanel.add(LightFOVTF);
	SensorsPanel.add(LightRangeTF);

    }

    public void MakeActionsPanel()
    {
	ActionPanel.setLayout(gridbag2);

	// build up ...
	ActionTopPanel.setLayout(new GridLayout(4,2));
	ActionBottomPanel.setLayout(new GridLayout(2,2));
	
	//ActionPanel.add(ActionTopPanel,BorderLayout.NORTH);
	//ActionPanel.add(ActionBottomPanel,BorderLayout.SOUTH);

        TitledBorder TopBorder= BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.black), "Energy consumption");
	TitledBorder BottomBorder= BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.black), "Energy collecting");

	ActionTopPanel.setBorder(TopBorder);
	ActionBottomPanel.setBorder(BottomBorder);

	JLabel EmptyLabel = new JLabel("  ");
	JLabel MovementLabel = new JLabel("Movement");
	JLabel MitoseLabel = new JLabel("Mitose");
	JLabel MeioseLabel = new JLabel("Meiose");
	JLabel PheromoneLabel = new JLabel("Pheromone output");
	JLabel SubstrateLabel = new JLabel("Substrate");
	JLabel LightLabel = new JLabel("Light");

	ActionTopPanel.add(MovementLabel);
	ActionTopPanel.add(EnergyMovementTF);
	ActionTopPanel.add(MitoseLabel);
	ActionTopPanel.add(EnergyMitoseTF);
	ActionTopPanel.add(MeioseLabel);
	ActionTopPanel.add(EnergyMeioseTF);
	ActionTopPanel.add(PheromoneLabel);
	ActionTopPanel.add(EnergyPOutputTF);

	ActionBottomPanel.add(SubstrateLabel);
	ActionBottomPanel.add(EnergySubstrateTF);
	ActionBottomPanel.add(LightLabel);
	ActionBottomPanel.add(EnergyLightTF);

	c2.gridx = 0;
        c2.gridy = 0;
        c2.gridwidth=10;
        c2.gridheight=5;
        c2.weightx=1;
        c2.weighty=1;
        c2.insets=new Insets(2,2,2,2);
        c2.fill = GridBagConstraints.BOTH;
        gridbag2.setConstraints(ActionTopPanel, c2);
        ActionPanel.add(ActionTopPanel);

	c2.gridx = 0;
        c2.gridy = 5;
        c2.gridwidth=10;
        c2.gridheight=5;
        c2.weightx=1;
        c2.weighty=1;
        c2.insets=new Insets(2,2,2,2);
        c2.fill = GridBagConstraints.BOTH;
        gridbag2.setConstraints(ActionBottomPanel, c2);
        ActionPanel.add(ActionBottomPanel);	

    }

    /*
    public void mouseClicked(MouseEvent e) {
 	Object src=e.getSource();

  	if (src==TabbedPane)
  	{
  	    System.out.println("Something ;)\n");
   	}
    } 
    */
    
    public SettingsDialog(){
	addWindowListener(new WindowAdapter() 
        {
	    public void windowClosing(WindowEvent e) 
	    {
		//System.exit(0);		
		setVisible(false);
            }
        });

	contentPane=getContentPane();
	contentPane.setLayout(gridbag);

	TabbedPane.addTab("Simulation",SimulationPanel);
	TabbedPane.addTab("Algaes",AlgaesPanel);
	TabbedPane.addTab("Sensors",SensorsPanel); 
	TabbedPane.addTab("Actions",ActionPanel);
	
	//TabbedPane.addMouseListener(this);

	TopPanel.setLayout(new GridLayout(1,1));
	TopPanel.add(TabbedPane);

	BottomPanel.setLayout(new GridLayout(1,3));
	BottomPanel.add(OKBtn);
	BottomPanel.add(AbortBtn);
	BottomPanel.add(DefaultCombo);

	c.gridx = 0;
        c.gridy = 0;
        c.gridwidth=23;
        c.gridheight=12;
        c.weightx=1;
        c.weighty=1;
        c.insets=new Insets(2,2,2,2);
        c.fill = GridBagConstraints.BOTH;
        gridbag.setConstraints(TopPanel, c);
        contentPane.add(TopPanel);

	c.gridx = 0;
        c.gridy = 12;
        c.gridwidth=23;
        c.gridheight=2;
        c.weightx=1;
        c.weighty=0;
        c.insets=new Insets(2,2,2,2);
        c.fill = GridBagConstraints.NONE;
        gridbag.setConstraints(BottomPanel, c);
        contentPane.add(BottomPanel);	

	MakeSimulationPanel();
	MakeAlgaesPanel();
	MakeSensorsPanel();
	MakeActionsPanel();
    }
}
